<template>
    <div
        :class="{
            'size-lg': size === 'lg',
            'dark': !!dark
        }"
    >
        <label
            v-if="!hideLabel"
            class="block text-sm font-medium capitalize"
            :class="{
                'border-red-500': errors && errors.length,
                'text-red-500': errors && errors.length,
                'font-black': boldLabel,
            }"
            @click="openSelect"
        >
            {{ label || name }}
        </label>
        <template
            v-if="fullScreen"
        >
            <div
                class="mt-1 relative rounded-sm shadow-sm cursor-pointer"
                @click="openSelect"
            >
                <div
                    class="focus:ring-indigo-500 focus:border-indigo-500 block w-full sm:text-sm border rounded-md p-2 pr-7 text-black bg-white"
                    :class="{
                    'pl-7': prependIcon,
                    'border-gray-300': !errors,
                    'border-red-500': errors && errors.length,
                    'text-red-500': errors && errors.length,
                }"
                >
                    {{ displayText }}
                </div>
                <div
                    class="absolute inset-y-0 right-0 pr-3 flex items-center cursor-pointer text-black"
                >
                <span
                    :class="{
                        'text-red-500': errors && errors.length,
                    }"
                >
                    <svg xmlns="http://www.w3.org/2000/svg" class="h-6 w-6" fill="none" viewBox="0 0 24 24" stroke="currentColor">
                        <path stroke-linecap="round" stroke-linejoin="round" stroke-width="2" d="M9 5l7 7-7 7" />
                    </svg>
                </span>
                </div>
            </div>
        </template>
        <template
            v-else
        >
            <div class="relative">
                <select
                    v-model="data"
                    :disabled="disabled || readonly"
                    class="form-control"
                    :class="{
                        'disabled': disabled || readonly,
                    }"
                >
                    <option
                        value=""
                        :selected="String(data) === ''"
                    >
                        {{ placeholder || $t('all') }}
                    </option>
                    <option
                        v-for="(opt, i) in options"
                        :key="`${name}-${i}`"
                        :value="opt.value"
                        :selected="String(data) === String(opt.value)"
                    >
                        {{ opt.text }}
                    </option>
                </select>
                <div class="pointer-events-none absolute inset-y-0 right-0 flex items-center px-2 text-gray-700">
                    <svg class="fill-current h-4 w-4" xmlns="http://www.w3.org/2000/svg" viewBox="0 0 20 20"><path d="M9.293 12.95l.707.707L15.657 8l-1.414-1.414L10 10.828 5.757 6.586 4.343 8z"/></svg>
                </div>
            </div>
        </template>
        <div
            v-if="note && Array.isArray(note)"
        >
            <div
                v-for="(n, i) in note"
                :key="`note-${i}`"
            >
                <div class="font-light font-sm">{{ n }}</div>
            </div>
        </div>
        <div
            v-else-if="note && !Array.isArray(note)"
        >
            <div class="font-light font-sm">{{ note }}</div>
        </div>
        <div
            v-if="errors && errors.length"
        >
            <div
                v-for="(err, i) in errors"
                :key="i"
            >
                <div class="font-light font-sm text-red-500">{{ err }}</div>
            </div>
        </div>
        <teleport
            v-if="selectOpened"
            to="body"
        >
            <div
                class="fixed absolute top-0 left-0 bottom-0 right-0 w-screen h-screen overflow-y-auto bg-white"
            >
                <div class="flex justify-between space-x-2 px-2 py-4 border-b">
                    <div
                        class="text-lg uppercase"
                    >
                        <div
                            class="font-bold uppercase"
                        >
                            {{ label || name }}
                        </div>
                        <div
                            v-if="placeholder"
                            class="text-gray-500 text-xs"
                        >
                            {{ placeholder }}
                        </div>
                    </div>
                    <div
                        class="cursor-pointer text-red-500"
                        @click="closeSelect"
                    >
                        <svg xmlns="http://www.w3.org/2000/svg" class="h-8 w-8" fill="none" viewBox="0 0 24 24" stroke="currentColor">
                            <path stroke-linecap="round" stroke-linejoin="round" stroke-width="2" d="M10 14l2-2m0 0l2-2m-2 2l-2-2m2 2l2 2m7-2a9 9 0 11-18 0 9 9 0 0118 0z" />
                        </svg>
                    </div>
                </div>
                <div class="grid grid-cols-1 divide-y">
                    <div
                        v-for="(opt, i) in options"
                        :key="`${name}-${i}`"
                        class="cursor-pointer w-full px-2 py-4 flex justify-between space-x-2"
                        @click="selected(opt)"
                    >
                        <div>
                            {{ opt.text }}
                        </div>
                        <div
                            v-if="(valueInteger && parseInt(modelValue) === parseInt(opt.value)) || (!valueInteger && modelValue === opt.value)"
                            class="text-green-400"
                        >
                            <svg xmlns="http://www.w3.org/2000/svg" class="h-6 w-6" fill="none" viewBox="0 0 24 24" stroke="currentColor">
                                <path stroke-linecap="round" stroke-linejoin="round" stroke-width="2" d="M9 12l2 2 4-4m6 2a9 9 0 11-18 0 9 9 0 0118 0z" />
                            </svg>
                        </div>
                        <div
                            v-else
                        >
                            <svg xmlns="http://www.w3.org/2000/svg" class="h-6 w-6" fill="none" viewBox="0 0 24 24" stroke="currentColor">
                                <path stroke-linecap="round" stroke-linejoin="round" stroke-width="2" d="M9 5l7 7-7 7" />
                            </svg>
                        </div>
                    </div>
                </div>
            </div>
        </teleport>
    </div>
</template>

<script setup>
import {computed, inject, onBeforeUnmount, ref, watch} from 'vue';
import {useI18n} from "vue-i18n";

const props = defineProps({
    id: {
        required: false,
        type: [String, Number],
        default: null,
    },
    name: {
        required: true,
        type: [String, Number],
    },
    label: {
        required: false,
        type: [String, Number],
        default: null,
    },
    boldLabel: {
        required: false,
        type: Boolean,
        default: false,
    },
    hideLabel: {
        required: false,
        type: Boolean,
        default: false,
    },
    placeholder: {
        required: false,
        type: [String, Number, Boolean],
        default: '',
    },
    note: {
        required: false,
        type: [String, Number, Array],
        default: null,
    },
    modelValue: {
        required: false,
        type: [String, Number, Boolean],
        default: '',
    },
    options: {
        required: true,
        type: Array
    },
    errors: {
        required: false,
        type: Array,
        default: () => [],
    },
    prependIcon: {
        required: false,
        type: [String],
        default: null,
    },
    disabled: {
        required: false,
        type: Boolean,
        default: false,
    },
    readonly: {
        required: false,
        type: Boolean,
        default: false,
    },
    valueInteger: {
        required: false,
        type: Boolean,
        default: true,
    },
    fullScreen: {
        required: false,
        type: Boolean,
        default: false,
    },
    size: {
        required: false,
        type: String,
        default: 'md',
    },
    dark: {
        required: false,
        type: Boolean,
        default: false,
    }
});
let data = ref(props.modelValue);
const $bus = inject('$bus');
const {t} = useI18n();
const emit = defineEmits(['update:modelValue', 'open', 'close']);
const selectOpened = ref(false);

const openSelect = () => {
    if (props.fullScreen && !props.readonly && !props.disabled) {
        $bus.emit('modal-opened');
        selectOpened.value = true;
        emit('open');
    }
};
const closeSelect = () => {
    $bus.emit('modal-closed');
    selectOpened.value = false;
    emit('close');
};

const displayText = computed(() => {
    if (props.modelValue) {
        let selected = props.options.find(r => {
            if (props.valueInteger) {
                return parseInt(r.value) === parseInt(props.modelValue);
            } else {
                return r.value === props.modelValue;
            }
        });

        if (selected) {
            return selected.text;
        } else {
            return props.placeholder || t('please_select');
        }
    } else {
        return props.placeholder || t('please_select');
    }
});

const selected = (opt) => {
    emit('update:modelValue', opt.value);
    closeSelect();
};

watch(data, (newValue) => {
    emit('update:modelValue', newValue);
});

const listenEsc = (evt) => {
    evt = evt || window.event;
    if (evt.keyCode === 27) {
        closeSelect();
    }
};

window.addEventListener('keyup', listenEsc);

onBeforeUnmount(() => {
    window.removeEventListener('keyup', listenEsc);
})
</script>
